"""
This Code is generated automatically by pyR@TE, 2013-9-20	 17:53:52 for the model : SM
"""
from __future__ import division
import numpy as np
def beta_function_SM(t,y,Assumptions={'two-loop':False,'diag': True}):
	#The Assumption can be used to incorporate some switch in the calculation
	kappa = 1./(16*np.pi**2)
	Id0 = np.eye(3)
	Id1 = np.eye(3)
	Id2 = np.eye(3)
	Y_u = np.matrix(np.zeros((3,3)))
	Y_u[0,0] = y[0]
	Y_u[0,1] = y[1]
	Y_u[0,2] = y[2]
	Y_u[1,0] = y[3]
	Y_u[1,1] = y[4]
	Y_u[1,2] = y[5]
	Y_u[2,0] = y[6]
	Y_u[2,1] = y[7]
	Y_u[2,2] = y[8]
	Y_e = np.matrix(np.zeros((3,3)))
	Y_e[0,0] = y[9]
	Y_e[0,1] = y[10]
	Y_e[0,2] = y[11]
	Y_e[1,0] = y[12]
	Y_e[1,1] = y[13]
	Y_e[1,2] = y[14]
	Y_e[2,0] = y[15]
	Y_e[2,1] = y[16]
	Y_e[2,2] = y[17]
	Y_d = np.matrix(np.zeros((3,3)))
	Y_d[0,0] = y[18]
	Y_d[0,1] = y[19]
	Y_d[0,2] = y[20]
	Y_d[1,0] = y[21]
	Y_d[1,1] = y[22]
	Y_d[1,2] = y[23]
	Y_d[2,0] = y[24]
	Y_d[2,1] = y[25]
	Y_d[2,2] = y[26]
	###############
	#beta functions
	###############
	#This is the mapping between rges and y[i]
	#{'Lambda_1': 30, 'Y_{e}': (9, 17), g1: 28, 'Y_{d}': (18, 26), 'mu_1': 31, g_SU3c: 29, 'Y_{u}': (0, 8), g_SU2L: 27}
	betaY_u = (-17*y[28]**2*Y_u/12 - 9*y[27]**2*Y_u/4 - 8*y[29]**2*Y_u + 3*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_u + Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_u + 3*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_u - 3*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/2 + 3*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/2)*kappa
	betaY_e = (-15*y[28]**2*Y_e/4 - 9*y[27]**2*Y_e/4 + 3*Id1*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_e + Id1*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_e + 3*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_e + 3*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/2)*kappa
	betaY_d = (-5*y[28]**2*Y_d/12 - 9*y[27]**2*Y_d/4 - 8*y[29]**2*Y_d + 3*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_d + Id2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_d + 3*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_d + 3*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/2 - 3*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/2)*kappa
	bLambda_1 = (12*y[30]**2 - 3*y[30]*y[28]**2 - 9*y[30]*y[27]**2 + 12*y[30]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) + 4*y[30]*np.trace(np.transpose(np.conjugate(Y_e))* Y_e) + 12*y[30]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u) + 3*y[28]**4/4 + 3*y[28]**2*y[27]**2/2 + 9*y[27]**4/4 - 12*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))) - 4*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))) - 12*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))))*kappa
	bg_SU2L = (-19*y[27]**3/6)*kappa
	bg1 = (41*y[28]**3/6)*kappa
	bg_SU3c = (-7*y[29]**3)*kappa
	bmu_1 = (6*y[30]*y[31] - 3*y[31]*y[28]**2/2 - 9*y[31]*y[27]**2/2 + 6*y[31]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) + 2*y[31]*np.trace(np.transpose(np.conjugate(Y_e))* Y_e) + 6*y[31]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u))*kappa
	if Assumptions['two-loop']:
		betaY_u = betaY_u + (3*y[30]**2*Y_u/2 - 6*y[30]*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u) + 1187*y[28]**4*Y_u/216 - 3*y[28]**2*y[27]**2*Y_u/4 + 19*y[28]**2*y[29]**2*Y_u/9 + 25*y[28]**2*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_u/24 + 25*y[28]**2*Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_u/8 + 85*y[28]**2*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_u/24 - 43*y[28]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/48 + 223*y[28]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/48 - 23*y[27]**4*Y_u/4 + 9*y[27]**2*y[29]**2*Y_u + 45*y[27]**2*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_u/8 + 15*y[27]**2*Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_u/8 + 45*y[27]**2*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_u/8 + 9*y[27]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/16 + 135*y[27]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/16 - 108*y[29]**4*Y_u + 20*y[29]**2*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_u + 20*y[29]**2*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_u - 16*y[29]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u) + 16*y[29]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u) + 15*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/4 - 27*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/4 + 5*Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/4 - 9*Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/4 + 15*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/4 - 27*Id0*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/4 + 3*Id0*np.trace(Y_u* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u)))*Y_u/2 - 3*Id0*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d)))*Y_u/4 - 27*Id0*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u)))*Y_u/4 - 27*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d)*Y_u/4 - 3*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))* Y_u)*Y_u/4 + 3*Id0*np.trace(np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d)*Y_u/2 - 9*Id0*np.trace(np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))* Y_e)*Y_u/4 + 11*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/4 - (Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u) - (Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/4 + 3*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/2)*kappa**2
		betaY_e = betaY_e + (3*y[30]**2*Y_e/2 - 6*y[30]*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e) + 457*y[28]**4*Y_e/24 + 9*y[28]**2*y[27]**2*Y_e/4 + 25*y[28]**2*Id1*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_e/24 + 25*y[28]**2*Id1*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_e/8 + 85*y[28]**2*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_e/24 + 129*y[28]**2*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/16 - 23*y[27]**4*Y_e/4 + 45*y[27]**2*Id1*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_e/8 + 15*y[27]**2*Id1*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_e/8 + 45*y[27]**2*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_e/8 + 135*y[27]**2*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/16 + 20*y[29]**2*Id1*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_e + 20*y[29]**2*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_e - 27*Id1*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/4 - 9*Id1*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/4 - 27*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/4 - 27*Id1*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d)))*Y_e/4 - 3*Id1*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u)))*Y_e/4 + 3*Id1*np.trace(Y_d* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d)))*Y_e/2 - 9*Id1*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e)))*Y_e/4 + 3*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u)*Y_e/2 - 3*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))* Y_d)*Y_e/4 - 27*Id1*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u)*Y_e/4 + 3*(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/2)*kappa**2
		betaY_d = betaY_d + (3*y[30]**2*Y_d/2 - 6*y[30]*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d) - 127*y[28]**4*Y_d/216 - 9*y[28]**2*y[27]**2*Y_d/4 + 31*y[28]**2*y[29]**2*Y_d/9 + 25*y[28]**2*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_d/24 + 25*y[28]**2*Id2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_d/8 + 85*y[28]**2*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_d/24 + 187*y[28]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/48 - 79*y[28]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/48 - 23*y[27]**4*Y_d/4 + 9*y[27]**2*y[29]**2*Y_d + 45*y[27]**2*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_d/8 + 15*y[27]**2*Id2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*Y_d/8 + 45*y[27]**2*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_d/8 + 135*y[27]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/16 + 9*y[27]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/16 - 108*y[29]**4*Y_d + 20*y[29]**2*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*Y_d + 20*y[29]**2*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*Y_d + 16*y[29]**2*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d) - 16*y[29]**2*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d) - 27*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/4 + 15*Id2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/4 - 9*Id2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/4 + 5*Id2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/4 - 27*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/4 + 15*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)*(Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/4 - 27*Id2*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d)))*Y_d/4 - 3*Id2*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u)))*Y_d/4 + 3*Id2*np.trace(Y_d* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d)))*Y_d/2 - 9*Id2*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e)))*Y_d/4 + 3*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u)*Y_d/2 - 3*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))* Y_d)*Y_d/4 - 27*Id2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u)*Y_d/4 + 3*(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/2 - (Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/4 - (Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d) + 11*(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/4)*kappa**2
		bLambda_1 = bLambda_1 + (-78*y[30]**3 + 18*y[30]**2*y[28]**2 + 54*y[30]**2*y[27]**2 - 72*y[30]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) - 24*y[30]**2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e) - 72*y[30]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u) + 629*y[30]*y[28]**4/24 + 39*y[30]*y[28]**2*y[27]**2/4 + 25*y[30]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)/6 + 25*y[30]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)/2 + 85*y[30]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)/6 - 73*y[30]*y[27]**4/8 + 45*y[30]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)/2 + 15*y[30]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)/2 + 45*y[30]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)/2 + 80*y[30]*y[29]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) + 80*y[30]*y[29]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u) - 3*y[30]*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d)))/2 - 15*y[30]*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u)))/2 - 3*y[30]*np.trace(Y_d* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))) - y[30]*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e)))/2 - 3*y[30]*np.trace(Y_u* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))) - 15*y[30]*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d)))/2 - 3*y[30]*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u)))/2 - 3*y[30]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/2 - 15*y[30]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))* Y_u)/2 - 3*y[30]*np.trace(np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d) - y[30]*np.trace(np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/2 - 3*y[30]*np.trace(np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u) - 15*y[30]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))* Y_d)/2 - 3*y[30]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/2 - 379*y[28]**6/24 - 559*y[28]**4*y[27]**2/24 + 5*y[28]**4*np.trace(Y_d* np.transpose(np.conjugate(Y_d)))/2 - 25*y[28]**4*np.trace(Y_e* np.transpose(np.conjugate(Y_e)))/2 - 19*y[28]**4*np.trace(Y_u* np.transpose(np.conjugate(Y_u)))/2 - 289*y[28]**2*y[27]**4/24 + 9*y[28]**2*y[27]**2*np.trace(Y_d* np.transpose(np.conjugate(Y_d))) + 11*y[28]**2*y[27]**2*np.trace(Y_e* np.transpose(np.conjugate(Y_e))) + 21*y[28]**2*y[27]**2*np.trace(Y_u* np.transpose(np.conjugate(Y_u))) + 8*y[28]**2*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d)))/3 - 8*y[28]**2*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))) - 16*y[28]**2*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u)))/3 + 305*y[27]**6/8 - 9*y[27]**4*np.trace(Y_d* np.transpose(np.conjugate(Y_d)))/2 - 3*y[27]**4*np.trace(Y_e* np.transpose(np.conjugate(Y_e)))/2 - 9*y[27]**4*np.trace(Y_u* np.transpose(np.conjugate(Y_u)))/2 - 64*y[29]**2*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))) - 64*y[29]**2*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))) + 60*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))) + 20*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))) - 12*np.trace(Y_u* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))) - 12*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))) + 12*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))) - 12*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))) + 60*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))))*kappa**2
		bg_SU2L = bg_SU2L + (3*y[28]**2*y[27]**3/2 + 35*y[27]**5/6 + 12*y[27]**3*y[29]**2 - 3*y[27]**3*np.trace(Y_d* np.transpose(np.conjugate(Y_d)))/2 - y[27]**3*np.trace(Y_e* np.transpose(np.conjugate(Y_e)))/2 - 3*y[27]**3*np.trace(Y_u* np.transpose(np.conjugate(Y_u)))/2)*kappa**2
		bg1 = bg1 + (199*y[28]**5/18 + 9*y[28]**3*y[27]**2/2 + 44*y[28]**3*y[29]**2/3 - 5*y[28]**3*np.trace(Y_d* np.transpose(np.conjugate(Y_d)))/6 - 5*y[28]**3*np.trace(Y_e* np.transpose(np.conjugate(Y_e)))/2 - 17*y[28]**3*np.trace(Y_u* np.transpose(np.conjugate(Y_u)))/6)*kappa**2
		bg_SU3c = bg_SU3c + (11*y[28]**2*y[29]**3/6 + 9*y[27]**2*y[29]**3/2 - 26*y[29]**5 - 2*y[29]**3*np.trace(Y_d* np.transpose(np.conjugate(Y_d))) - 2*y[29]**3*np.trace(Y_u* np.transpose(np.conjugate(Y_u))))*kappa**2
		bmu_1 = bmu_1 + (-15*y[30]**2*y[31] + 12*y[30]*y[31]*y[28]**2 + 36*y[30]*y[31]*y[27]**2 - 36*y[30]*y[31]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) - 12*y[30]*y[31]*np.trace(np.transpose(np.conjugate(Y_e))* Y_e) - 36*y[30]*y[31]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u) + 557*y[31]*y[28]**4/48 + 15*y[31]*y[28]**2*y[27]**2/8 + 25*y[31]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)/12 + 25*y[31]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)/4 + 85*y[31]*y[28]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)/12 - 145*y[31]*y[27]**4/16 + 45*y[31]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d)/4 + 15*y[31]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_e))* Y_e)/4 + 45*y[31]*y[27]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u)/4 + 40*y[31]*y[29]**2*np.trace(np.transpose(np.conjugate(Y_d))* Y_d) + 40*y[31]*y[29]**2*np.trace(np.transpose(np.conjugate(Y_u))* Y_u) - 27*y[31]*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d)))/4 - 27*y[31]*np.trace(Y_d* np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u)))/4 - 9*y[31]*np.trace(Y_d* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d)))/2 - 9*y[31]*np.trace(Y_e* np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e)))/4 - 9*y[31]*np.trace(Y_u* np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u)))/2 - 27*y[31]*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d)))/4 - 27*y[31]*np.trace(Y_u* np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u)))/4 - 27*y[31]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_d))* Y_d)/4 - 3*y[31]*np.trace(np.transpose(np.conjugate(Y_d))* Y_d* np.transpose(np.conjugate(Y_u))* Y_u)/4 + 3*y[31]*np.trace(np.transpose(np.conjugate(Y_d))* Y_u* np.transpose(np.conjugate(Y_u))* Y_d)/2 - 9*y[31]*np.trace(np.transpose(np.conjugate(Y_e))* Y_e* np.transpose(np.conjugate(Y_e))* Y_e)/4 + 3*y[31]*np.trace(np.transpose(np.conjugate(Y_u))* Y_d* np.transpose(np.conjugate(Y_d))* Y_u)/2 - 3*y[31]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_d))* Y_d)/4 - 27*y[31]*np.trace(np.transpose(np.conjugate(Y_u))* Y_u* np.transpose(np.conjugate(Y_u))* Y_u)/4)*kappa**2
	if Assumptions['diag'] :
		return [betaY_u[0,0], 0,0,0,betaY_u[1,1], 0,0,0,betaY_u[2,2], betaY_e[0,0], 0,0,0,betaY_e[1,1], 0,0,0,betaY_e[2,2], betaY_d[0,0], 0,0,0,betaY_d[1,1], 0,0,0,betaY_d[2,2], bg_SU2L, bg1, bg_SU3c, bLambda_1, bmu_1]
	else :
		return [betaY_u[0,0], betaY_u[0,1], betaY_u[0,2], betaY_u[1,0], betaY_u[1,1], betaY_u[1,2], betaY_u[2,0], betaY_u[2,1], betaY_u[2,2], betaY_e[0,0], betaY_e[0,1], betaY_e[0,2], betaY_e[1,0], betaY_e[1,1], betaY_e[1,2], betaY_e[2,0], betaY_e[2,1], betaY_e[2,2], betaY_d[0,0], betaY_d[0,1], betaY_d[0,2], betaY_d[1,0], betaY_d[1,1], betaY_d[1,2], betaY_d[2,0], betaY_d[2,1], betaY_d[2,2], bg_SU2L, bg1, bg_SU3c, bLambda_1, bmu_1]
